Foreman - Bug #37215

Getting "undefined method '#id' for NilClass::Jail (NilClass)" error when generating Ansible inventory
report

02/29/2024 05:26 AM - Hao Yu

Status: Closed
Priority: Normal
Assignee: Hao Yu
Category: Reporting
Target version:
Difficulty: Fixed in Releases: 3.11.0
Triaged: No Found in Releases:
Bugzilla link: 2266794 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/10074
Description

Clone from bugzilla https:/bugzilla.redhat.com/show_bug.cqi?id=2266794

Description of problem:
Getting the following error when generating the Ansible inventory report.

Safemode: :NoMethodError
undefined method '#id' for NilClass::Jail (NilClass)
- "/usr/share/gems/gems/safemode-1.3.8/1lib/safemode/jail.rb:22:in ‘method_missing'"
- Ansible - Ansible Inventory:89:in "block in initialize'
- "/usr/share/gems/gems/activerecord-6.1.7.4/1lib/active_record/relation/batches/batch_enumerator.r
b:40:in
"block (2 levels) in each_record'"
- "/usr/share/gems/gems/activerecord-6.1.7.4/1lib/active_record/relation/batches/batch_enumerator.r
b:40:1in
‘each'"
- "/usr/share/gems/gems/activerecord-6.1.7.4/1lib/active_record/relation/batches/batch_enumerator.r
b:40:1in
"block in each_record'"
- "/usr/share/gems/gems/activerecord-6.1.7.4/1lib/active_record/relation/batches.rb:245:in
"block in in_batches'"
- "/usr/share/gems/gems/activerecord-6.1.7.4/1ib/active_record/relation/batches.rb:229:in
“loop'"
- "/usr/share/gems/gems/activerecord-6.1.7.4/1lib/active_record/relation/batches.rb:229:in
“in_batches'"
- "/usr/share/gems/gems/activerecord-6.1.7.4/1lib/active_record/relation/batches/batch_enumerator.r
163 39 g alin
“each'"
- "/usr/share/gems/gems/activerecord-6.1.7.4/1lib/active_record/relation/batches/batch_enumerator.r
b:39:in
‘each_record'"
- "/usr/share/gems/gems/safemode-1.3.8/1lib/safemode/jail.rb:31:in ‘method_missing'"
- Ansible - Ansible Inventory:83:in “initialize'
- "/usr/share/gems/gems/safemode-1.3.8/1lib/safemode.rb:52:in “eval'"
- "/usr/share/gems/gems/safemode-1.3.8/1lib/safemode.rb:52:in “eval'"
- "/usr/share/foreman/app/services/foreman/renderer/safe_mode_renderer.rb:7:in "render'"
— "/usr/share/foreman/app/services/foreman/renderer/base_renderer.rb:18:in “render'"
- "/usr/share/foreman/app/services/foreman/renderer.rb:46:in "render'"
- "/usr/share/foreman/app/models/template.rb:172:in "render'"
— "/usr/share/foreman/app/models/report_composer.rb:241:in "render'"
- "/usr/share/foreman/app/jobs/template_render_job.rb:12:in “block in perform'"
- "/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:108:in ‘as'"
- "/usr/share/foreman/app/jobs/template_render_Jjob.rb:9:in ‘perform'"
- "/usr/share/gems/gems/activejob-6.1.7.4/1ib/active_job/execution.rb:48:in “block
in perform_now'"

- "/usr/share/gems/gems/activesupport—6.1.7.4/1lib/active_support/callbacks.rb:117:in
“block in run_callbacks'"

- "/usr/share/gems/gems/118n-1.13.0/1ib/i18n.rb:322:in ‘with_locale'"

- "/usr/share/gems/gems/activejob-6.1.7.4/1ib/active_job/translation.rb:9:in “block
(2 levels) in <module:Translation>"'"

- "/usr/share/gems/gems/activesupport-6.1.7.4/1lib/active_support/callbacks.rb:126:in
‘instance_exec'"

- "/usr/share/gems/gems/activesupport-6.1.7.4/1lib/active_support/callbacks.rb:126:in
"block in run_callbacks'"

- "/usr/share/gems/gems/activesupport-6.1.7.4/1ib/active_support/core_ext/time/zones.rb:66:1in
‘use_zone'"

- "/usr/share/gems/gems/activejob-6.1.7.4/1lib/active_job/timezones.rb:9:in “block
(2 levels) in <module:Timezones>"'"

- "/usr/share/gems/gems/activesupport-6.1.7.4/1lib/active_support/callbacks.rb:126:in
‘instance_exec'"

- "/usr/share/gems/gems/activesupport-6.1.7.4/1lib/active_support/callbacks.rb:126:in
"block in run_callbacks'"

- "/usr/share/gems/gems/activejob-6.1.7.4/1lib/active_job/instrumentation.rb:21:1in
"block in instrument'"

- "/usr/share/gems/gems/activesupport-6.1.7.4/1lib/active_support/notifications.rb:203:in
"block in instrument'"

- "/usr/share/gems/gems/activesupport-6.1.7.4/1ib/active_support/notifications/instrumenter.rb:24:

in
‘instrument'"

- "/usr/share/gems/gems/activesupport—6.1.7.4/1lib/active_support/notifications.rb:203:1in
“instrument'"

- "/usr/share/gems/gems/activejob-6.1.7.4/1lib/active_job/instrumentation.rb:31:in
‘instrument'"

How reproducible:
Easy

Steps to Reproduce:

1. Has some hosts not associated to any content view or LCE. The satellite host entry itself should be sufficient to reproduce.
2. Navigate to Monitor -> Report Templates -> "Ansible - Ansible Inventory" -> Click "Generate" button

3. Set "Yes" for Content Attributes and click Generate button.

Actual results:
Safemode::NoMethodError
undefined method '#id' for NilClass::Jail (NilClass)

Expected results:
Report generates successfully

Additional info:
Similar issue to bug #2256411 but different report template.

Associated revisions

Revision b6bae776 - 04/05/2024 01:35 PM - Hao Yu
Fixes #37215 - Stop reporting CV/LCE if not set to hosts

History

#1 - 02/29/2024 05:48 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Hao Yu

- Pull request https://github.com/theforeman/foreman/pull/10074 added
#2 - 03/01/2024 03:57 PM - vi won

Did some testing. We use this as well to sync inventory from Foreman->AWX. It seems to only happen when "Content Attributes" is set to yes. If
you disable that option in the report, it seems to generate ok.
#3 - 03/06/2024 06:03 PM - ebarrere please_edit_me

vi won wrote in #note-2:

Did some testing. We use this as well to sync inventory from Foreman->AWX. It seems to only happen when "Content Attributes" is set to yes.
If you disable that option in the report, it seems to generate ok.

Thanks! I'm having the same issue and this workaround will save me.

#4 - 04/05/2024 01:35 PM - The Foreman Bot
- Fixed in Releases 3.11.0 added

#5 - 04/05/2024 02:00 PM - Hao Yu
- Status changed from Ready For Testing to Closed

Applied in changeset foreman|b6bae776dc81364f474b455d36905097598bfa5c.
